﻿
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

using School_Entity;
using School_BLL;
namespace School_Web.admin.basic
{
    public partial class autoidlist : BasicWeb
    {
        /// <summary>
        /// 页面初始化的时候操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public string sSQL = string.Empty;
        public SkyTools res = new SkyTools();
        protected void Page_Load(object sender, EventArgs e)
        {
            P_Sky_Redirect = "autoidmanage.aspx";
            P_Sky_STName = "SkyAutoID";
            P_Sky_STInfo = "自动编号";
            if (!Page.IsPostBack)
            {
                SkyMustAdministrator();
                SkyShowDefaultInfo();
                BtnSearch();
            }
        }

   

        /// <summary>
        /// 生成查询的SQL命令
        /// </summary>

        public void SkyBindSQL()
        {
            sSQL = "select * from " + P_Sky_STName + " where 1=1 ";
            string sSearch = string.Empty;
            string sTmp;

            
            sTmp = this.SkyTool_String_ReplaceBadChar(this.txtName.Text.ToString());
            if (sTmp != "")
            {
                sSearch += " and AutoInfo like '%" + sTmp + "%'";
            }

            if (sSearch != "")
            {
                sSQL += sSearch;
            }
            sSQL += " order by id desc";

            //调用排序JS
            SkyToolMessageJS(" WindowAJAXReload();");
        }


        /// <summary>
        /// GridView行绑定的时候触发,进行数据的特殊处理
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        protected void gvInfo_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                SkyGridViewRow(e);
                string sID;
                sID = e.Row.Cells[0].Text.ToString();
                TableCell tc;
                tc = e.Row.Cells[7];
                LinkButton lnkb;
                lnkb = (LinkButton)tc.Controls[0];
                lnkb.Attributes.Add("onclick", SkyGetEdit(P_Sky_Redirect, sID));
            }
        }


        #region 不经常修改的代码

        /// <summary>
        /// 顶部导航按钮的事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        protected void SkyLnkBAMD_Click(object sender, EventArgs e)
        {
            LinkButton lnkb;
            lnkb = (LinkButton)sender;
            string slnkbName;
            slnkbName = lnkb.ID.ToLower();
            int iCurrent = Pager.CurrentPageIndex;
            switch (slnkbName)
            {
                case "lnkbadd":
                    if (P_Sky_Redirect == "") { } else { Response.Redirect(P_Sky_Redirect); }
                    break;
                case "lnkbmodify":
                    break;
                case "lnkbdelete":
                    SkyDelete();
                    break;
                case "lnkbexcel":
                    SkyExcelGridView(this.gvInfo);
                    break;
                default:
                    break;
            }
        }

        /// <summary>
        /// 删除数据的时候公用信息需要提出来的数据
        /// </summary>

        protected void SkyDelete()
        {
            SkyDeleteList(P_Sky_STName, P_Sky_STInfo);
        }


        /// <summary>
        /// 删除GridView选择的项目
        /// </summary>

        protected void SkyDeleteList(string sTName, string sLogInfo)
        {
            SkyDelteList(SkyWriteLog_FuncID.System,sTName, sLogInfo, gvInfo);
            BtnSearch();
        }

        /// <summary>
        /// 分页函数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Pager_PageChanged(object sender, EventArgs e)
        {
            
            SkyBindSQL();
            BindRepeater();
            
        }

        /// <summary>
        /// 搜索功能
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        protected void btnSearch_Click(object sender, EventArgs e)
        {
            BtnSearch();
        }

        /// <summary>
        /// 搜索功能
        /// </summary>
        public void BtnSearch()
        {
            SkyThreading();
            SkyBindSQL();
            SkyBindCount();
            BindRepeater();
        }

        /// <summary>
        /// 计算总页数
        /// </summary>
        public void SkyBindCount()
        {
            int totalOrders = Convert.ToInt32(res.SkyGetSQLCount(sSQL));
            Pager.RecordCount = totalOrders;
        }

        /// <summary>
        /// 绑定数据列表
        /// </summary>

        protected void BindRepeater()
        {
            SkyBindSQL();
            SkyThreading();
            DataTable dt;
            dt = res.SkyDataTablePage(sSQL, Pager.CurrentPageIndex, Pager.PageSize);
            this.gvInfo.DataSource = dt;
            this.gvInfo.DataBind();
        }

        #endregion
    }
}
