﻿
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

using School_Entity;
using School_BLL.ver3.clsV3Basic;
using School_Tools;

namespace School_Web.admin.basic
{

    public partial class printconfiglist : BasePageV3
    {
        #region 页面加载事件

        SkyPrintConfigService res = new SkyPrintConfigService();
        SkyPrintConfig entity = new SkyPrintConfig();

        protected void Page_Load(object sender, EventArgs e)
        {
            pDefault.sTInfo = "打印模板";
            pDefault.sAddUrl = "printconfigmanager.aspx";
            pDefault.sTName = entity.GetType().Name;
            pDefault.sEditUrl = pDefault.sAddUrl;
            pDefault.sExcelTitle = "序号,模板关键字,模板名称,纸张方向,居中打印,主标题文字,建立时间,修改时间";
            pDefault.sExcelValue = "ID,PKey,PName,PCOrientationName,PCCenterPrintName,PContentTitle,CreateDate,UpdateDate";


            if (!Page.IsPostBack)
            {
                UsShowDefaultInfo();
                
                BindRepeater();
            }
        }

        #endregion

        #region 查询功能

        protected void BindRepeater()
        {
            #region 声明查询变量

            entity.sPKey = this.txtPKey.Text.Trim();
            entity.sPName = this.txtPName.Text.Trim();

            #endregion

            #region 整理分页数据

            PaginationPage pPage = new PaginationPage();
            pPage.iPageIndex = Pager.CurrentPageIndex;
            pPage.iPageSize = Pager.PageSize;
            
            #endregion

            #region 调用分页并返回

            int iReturn = res.GetList(entity, ref pPage);
            if (iReturn == 0)
            {
                this.Pager.RecordCount = pPage.iRecordCount;

                this.rptInfo.DataSource = pPage.dt;
                this.rptInfo.DataBind();
                ViewState["sSQLExcel"] = pPage.sSQL;
            }

            #endregion

        }

        #endregion

        #region 搜索

        protected void btnSearch_Click(object sender, EventArgs e)
        {
            BindRepeater();
        }

        #endregion

        #region LinkButton按钮事件
        
        protected void SkyLnkBAMD_Click(object sender, EventArgs e)
        {
            LinkButton lnkb;
            lnkb = (LinkButton)sender;
            string slnkbName;
            slnkbName = lnkb.ID.ToLower();
            int iCurrent = Pager.CurrentPageIndex;
            switch (slnkbName)
            {
                case "lnkbadd":
                    if (pDefault.sAddUrl != "") { Response.Redirect(pDefault.sAddUrl); }
                    break;
                case "lnkbmodify":
                    break;
                case "lnkbdelete":
                    UsDeleteList();
                    break;
                case "lnkbexcel":
                    UsExcelALL2013(pDefault.sExcelTitle, pDefault.sExcelValue);

                    break;
                default:
                    break;
            }
        }

        #endregion

        #region 分页事件

        protected void Pager_PageChanged(object sender, EventArgs e)
        {
            BindRepeater();
        }

        #endregion

        #region 删除数据

        /// <summary>
        /// 删除数据的时候公用信息需要提出来的数据
        /// </summary>

        protected void UsDeleteList()
        {
            UsDeleteList(pDefault.sTName, pDefault.sTInfo);
        }


        /// <summary>
        /// 删除GridView选择的项目
        /// </summary>

        protected void UsDeleteList(string sTName, string sLogInfo)
        {
            UsDeleteList(FuncID.SkySalaryFiled, sTName, sLogInfo, rptInfo);
            BindRepeater();
        }

        #endregion

        

    }
}
