﻿
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using School_Entity;
using School_BLL.clsPublic;

namespace School_Web.admin.basic
{
    public partial class softregister : BasicWeb
    {

        /// <summary>
        /// 系统初始化的时候调用
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        
        protected void Page_Load(object sender, EventArgs e)
        {
            //Response.Charset("GB2312");

            if (!Page.IsPostBack)
            {
                //SkyMustAdministrator();
                ShowCheckBox();
                SkyLoadDefault();
                SkyShowDefaultInfo();
                ShowState();
            }
        }

        protected void ShowCheckBox()
        {
            sModelZ = sModelName.Split(",".ToCharArray());
            chkFunction.Items.Clear();
            for (int i = 0; i < sModelZ.Length; i++)
            {
                chkFunction.Items.Add(sModelZ[i].ToString());
            }
        }

        protected void ShowState()
        {
            string sAssembly = "", sTmp = "";
            sTmp = "<a href='#' onClick='skycopyright();'>{0}</a>";
            if (Global.appUInfo.WebRegtype != "0")
            {
                sAssembly = "<img src='/admin/images/zs.gif' title='" + GetCustomAssembly().ToString() + "'>" + string.Format(sTmp, "正式版本");
            }
            else
            {
                sAssembly = "<img src='/admin/images/sy.gif' title='" + GetCustomAssembly().ToString() + "'>" + string.Format(sTmp, "试用版本");
            }
            string sInfo = @"";
            this.LiteralGetAssembly.Text = sAssembly + sInfo;

        }

        /// <summary>
        /// 加载默认数据
        /// </summary>
        protected void SkyLoadDefault()
        {

            string sLic;
            sLic = School_BLL.SkyFile.FileReadVirtual(sLicPath);
            bool b = false;
            if (sLic != "")
            {
                UserLicInfo UInfo = new UserLicInfo();
                UInfo = GetKey(sLic, sKey);
                if (UInfo.WebRegtype != "0")
                {
                    if (UInfo.WebIP != CareFGetIP())
                    {
                        b = true;
                    }
                    else if (UInfo.WebMac != CareFGetMac())
                    {
                        b = true;
                    }
                    else if (UInfo.WebPort != CareFGetPort())
                    {
                        b = true;
                    }
                    else if (!SkySoftAssembly(Utils.AssemblyFileVersion, UInfo.WebAssemblyVersion))
                    {
                        b = true;
                    }
                    else
                    {

                        this.txtWebEnddate.Text = UInfo.WebEnddate;
                        this.txtWebIP.Text = UInfo.WebIP;
                        this.txtWebMac.Text = UInfo.WebMac;
                        this.txtWebName.Text = UInfo.WebName;
                        this.txtWebAssemblyVersion.Text = UInfo.WebAssemblyVersion;
                        this.txtWebOnline.Text = UInfo.WebOnline;
                        this.txtWebPort.Text = UInfo.WebPort;
                        this.txtWebRegdate.Text = UInfo.WebRegdate;
                        this.txtWebTel.Text = UInfo.WebTel;
                        this.txtWebUrl.Text = UInfo.WebUrl;
                        this.txtWebUserName.Text = UInfo.WebUserName;
                        this.btnSubmit.Text = "正式用户";
                        this.txtLicFinish.Text = sLic;
                        this.btnSubmit.Enabled = false;
                        //this.btnOK.Enabled = false;

                        #region 计算授权功能模块
                        string sModel = UInfo.WebModelLic;
                        CheckBox chk;
                        string sTmp = "";
                        for (int i = 0; i < this.chkFunction.Items.Count; i++)
                        {
                            if (sModel.Length > i)
                            {
                                if (sModel.Substring(i, 1) == "1")
                                {
                                    this.chkFunction.Items[i].Selected = true;
                                }
                                else
                                {
                                    this.chkFunction.Items[i].Enabled = false;
                                }
                            }
                        }
                        #endregion
                    }
                }
            }
            else
            {
                b = true;
            }
            #region 是否调用默认信息
            if (b == true)
            {
                SkyLoadDefaultOk();
            }
            #endregion
            
        }

        public void SkyLoadDefaultOk()
        {
            this.txtWebEnddate.Attributes.Add("onClick", "WdatePicker({skin:'whyGreen',isShowClear:false,readOnly:true,dateFmt:'yyyy-MM-dd'});");
            //this.txtWebRegdate.Attributes.Add("onClick", "WdatePicker({skin:'whyGreen',isShowClear:false,readOnly:true,dateFmt:'yyyy-MM-dd'});");
            this.txtWebRegdate.Text = DateTime.Now.ToString("yyyy-MM-dd");
            this.txtWebEnddate.Text = DateTime.Now.AddYears(2).ToString("yyyy-MM-dd");
            this.txtWebAssemblyVersion.Text = Utils.AssemblyFileVersion.Trim();
            this.txtWebAssemblyVersion.ReadOnly = true;
            this.txtWebIP.Text = CareFGetIP();
            this.txtWebMac.Text = CareFGetMac();
            this.txtWebPort.Text = CareFGetPort();
            this.txtWebUrl.Text = CareFGetURL();
        }

        /// <summary>
        /// 处理增加和删除事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            SkyThreading();
            if (PageAuthentication(this.Page.Controls))
            {
                UserLicInfo UInfo = new UserLicInfo();
                UInfo.WebEnddate = this.txtWebEnddate.Text.Trim();
                UInfo.WebIP = this.txtWebIP.Text.Trim();
                UInfo.WebMac = this.txtWebMac.Text.Trim();
                UInfo.WebName = this.txtWebName.Text.Trim();
                UInfo.WebAssemblyVersion = this.txtWebAssemblyVersion.Text.Trim();
                UInfo.WebOnline = this.txtWebOnline.Text.Trim();
                UInfo.WebPort = this.txtWebPort.Text.Trim();
                UInfo.WebRegdate = this.txtWebRegdate.Text.Trim();
                UInfo.WebRegtype = "0";
                UInfo.WebTel = this.txtWebTel.Text.Trim();
                UInfo.WebUrl = this.txtWebUrl.Text.Trim();
                UInfo.WebUserName = this.txtWebUserName.Text.Trim();

                #region 计算授权功能模块
                string sModel = "";
                for (int i = 0; i < chkFunction.Items.Count; i++)
                {
                    if (this.chkFunction.Items[i].Selected)
                    {
                        sModel += "1";
                    }
                    else
                    {
                        sModel += "0";
                    }
                }
                UInfo.WebModelLic = sModel;
                #endregion

                this.txtLicTmp.Text = SetKey(UInfo, sKey);
                this.btnOK.Enabled = true;
            }  
        }

        protected void btnOK_Click(object sender, EventArgs e)
        {
            UserLicInfo UInfo = new UserLicInfo();
            string sLic;
            sLic = this.txtLicFinish.Text.Trim();
            UInfo = GetKey(sLic, sKey);
            string sReturn = "";
            if (UInfo.WebRegtype != "0")
            {
                if (UInfo.WebIP != CareFGetIP())
                {
                    sReturn = "授权文件IP地址不正确！"; 
                }else if (UInfo.WebMac != CareFGetMac())
                {
                    sReturn = "授权文件网卡地址不正确！";
                }
                else if (UInfo.WebPort != CareFGetPort())
                {
                    sReturn = "授权文件端口不正确！";
                }
                else if (!SkySoftAssembly(Utils.AssemblyFileVersion, UInfo.WebAssemblyVersion))
                {
                    sReturn = "授权文件版本不正确！";
                }
                else
                {
                    this.txtWebEnddate.Text = UInfo.WebEnddate;
                    this.txtWebIP.Text = UInfo.WebIP;
                    this.txtWebMac.Text = UInfo.WebMac;
                    this.txtWebName.Text = UInfo.WebName;
                    this.txtWebAssemblyVersion.Text = UInfo.WebAssemblyVersion;
                    this.txtWebOnline.Text = UInfo.WebOnline;
                    this.txtWebPort.Text = UInfo.WebPort;
                    this.txtWebRegdate.Text = UInfo.WebRegdate;
                    this.txtWebTel.Text = UInfo.WebTel;
                    this.txtWebUrl.Text = UInfo.WebUrl;
                    this.txtWebUserName.Text = UInfo.WebUserName;

                    #region 计算授权功能模块
                    string sModel = UInfo.WebModelLic;
                    for (int i = 0; i < this.chkFunction.Items.Count; i++)
                    {
                        if (sModel.Length >= i)
                        {
                            if (sModel.Substring(i, 1) == "1")
                            {
                                this.chkFunction.Items[i].Selected = true;
                            }
                            else
                            {
                                this.chkFunction.Items[i].Enabled = false;
                            }
                        }
                    }
                    #endregion


                    bool bReturn = School_BLL.SkyFile.FileWriteVirtual(sLicPath, sLic,false);
                    sReturn = "恭喜您，注册成功，感谢您成为我们的正式用户！";
                    //给公用变量更新授权信息
                    Global.appUInfo = UInfo;

                    if (bReturn)
                    {
                        this.SkyToolMessage(sReturn, "/admin/skyDefault.aspx");
                    }
                    else
                    {
                        this.SkyToolMessage("恭喜您，注册成功，感谢您成为我们的正式用户！但是因为您的系统权限配置问题，注册文件无法写入文件careff.lic到站点根目录，请手动配置权限，或者把授权码放到careff.lic文件后放到站点根目录！");
                    }
                   
                    
                }
            }
            else
            {
                sReturn = "非正式版本授权文件！";
            }
            this.SkyToolMessage(sReturn);
        }
    }
}
